package wjc.zxb.method;

import java.io.FileInputStream;
import java.security.KeyStore;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.Signature;
import java.security.cert.Certificate;
import java.security.cert.X509Certificate;
import java.util.Base64;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class CertificatePrivateKeyEncryption {

   private static Log log = LogFactory.getLog(CertificatePrivateKeyEncryption.class);
   public static final String ZX9901 = "ZX9901";
   public static final String ZX9902 = "ZX9902";
   public static final String ZX9903 = "ZX9903";
   public static final String ZX9904 = "ZX9904";
   public static final String ZX9906 = "ZX9906";
   public static final String ZX9907 = "ZX9907";
   public static final String ZX9908 = "ZX9908";
   public static final String ZX9909 = "ZX9909";
   public static final String ZX9910 = "ZX9910";
   public static final String ZX9911 = "ZX9911";
   public static final String ZX9912 = "ZX9912";
   public static final String ZX9913 = "ZX9913";
   public static final String ZX9914 = "ZX9914";
   public static final String ZX9921 = "ZX9921";
   public static final String ZX9922 = "ZX9922";
   public static final String ZX9923 = "ZX9923";
   public static final String ZX9924 = "ZX9924";
   public static final String ZX9925 = "ZX9925";
   public static final String ZX9926 = "ZX9926";
   public static final String ZX9927 = "ZX9927";
   public static final String ZX9930 = "ZX9930";
   public static final String ZX9931 = "ZX9931";
   public static final String ZX9932 = "ZX9932";
   public static final String ZX9933 = "ZX9933";
   public static final String ZX9940 = "ZX9940";
   public static final String ZX9943 = "ZX9943";
   public static final String ZX9944 = "ZX9944";
   public static final String ZX9945 = "ZX9945";


   public static Map getSign(String data) {
      HashMap map = new HashMap();
      String signBase64 = "";

      try {
         String e = "D:\\WEAVER\\证书\\xinbao20250630.pfx";
         char[] password = "123456Nb".toCharArray();
         KeyStore keyStore = KeyStore.getInstance("PKCS12");
         FileInputStream fis = new FileInputStream(e);
         keyStore.load(fis, password);
         fis.close();
         String alias = (String)keyStore.aliases().nextElement();
         Certificate certificate = keyStore.getCertificate(alias);
         PublicKey publicKey = certificate.getPublicKey();
         PrivateKey privateKey = (PrivateKey)keyStore.getKey(alias, password);
         Signature signature = Signature.getInstance("SHA256withRSA");
         signature.initSign(privateKey);
         signature.update(data.getBytes("UTF-8"));
         byte[] signBytes = signature.sign();
         signBase64 = Base64.getEncoder().encodeToString(signBytes);
         System.out.println("Signature: " + signBase64);
         String certString = "";
         Enumeration aliases = keyStore.aliases();

         while(aliases.hasMoreElements()) {
            alias = (String)aliases.nextElement();
            if(keyStore.isKeyEntry(alias)) {
               Certificate[] certChain = keyStore.getCertificateChain(alias);
               X509Certificate x509Cert = (X509Certificate)certChain[0];
               certString = new String(Base64.getEncoder().encode(x509Cert.getEncoded()));
            }
         }

         map.put("signBase64", signBase64);
         map.put("resutl_gy", certString);
      } catch (Exception var17) {
         log.error("问题===" + var17.getMessage());
      }

      return map;
   }

   public static void main(String[] args) {
      getSign("pzDPtnY6/OXXLSO+zXgYLsfof77WPEAZ8Wf0mOedFJc=");
   }

}
